Skip to content

Export types overview ​

This overview lists all available export types, their endpoints, supported output formats, and parameters.

The full asynchronous workflow is described in the exports section.

Availability

Exports are available only for Business and Enterprise plans.

How to read parameters ​

  • Endpoint calls use POST /api/{version}/ExportRequest/{type}.
  • All parameters listed in the tables below (for example DateFrom, DateTo, IdStaff) are sent in the request body (application/json).
  • Only generic export options belong to query string: format, password, email, callback.
  • Date and time values in export files without Utc in the field name are XDENT local time. Fields with Utc in the name are true UTC.

General exports ​

Test export ​

POST /api/v1/ExportRequest/Test

Test export intended for testing export integration.

  • This export supports CSV format only.

Parameters ​

This endpoint has no request-body parameters.

You can use generic export options in query string:

ParameterTypeRequiredDescription
formatstringnoExport output format (CSV)
passwordstringnoPassword for the generated ZIP file
emailstringnoEmail for notification after export completion
callbackstringnoCallback URL called after export completion

Response ​

ColumnValue
Export TypeAlways TEST
Generated At UTCCurrent UTC time at export generation (ISO O format)
Job IDExport identifier

Invoicing ​

POST /api/v1/ExportRequest/Invoices

Detailed export of client invoices, including line items.

This export is based on an older implementation and will be replaced by a newer version in the future.

  • This export is available only in JSON format.

Parameters ​

ParameterTypeRequiredDescription
DateFromdatetimeyesStart of the data range by invoice issue or modification date
DateTodatetimeyesEnd of the data range by invoice issue or modification date

Response ​

Response is an InvoiceExportInfo object.

FieldTypeDescription
dateCreateddatetimeExport creation date
companiesInvoiceExportCompanyInfo[]Companies included in the export
InvoiceExportCompanyInfo ​
FieldTypeDescription
idCRMstringExternal company identifier
companyNamestringCompany name
clientsInvoiceExportClientInfo[]Clients with records in the export
InvoiceExportClientInfo ​
FieldTypeDescription
idClientuuidClient identifier
fullNamestringClient full name
phonestringClient phone
emailstringClient email
citystringClient city
streetstringClient street
poststringClient ZIP/postal code
staffNamestringResponsible staff name
clientIdintNumeric client ID
staffIdintNumeric staff ID
reportsInvoiceExportMedicalReportInfo[]Client medical records
invoicesInvoiceExportInvoiceInfo[]Client documents
InvoiceExportMedicalReportInfo ​
FieldTypeDescription
IdMedicalReportuuidMedical record identifier
datedatetimeMedical record date
insuranceItemsInvoiceExportInsuranceItemInfo[]Insurance items in the medical record
InvoiceExportInsuranceItemInfo ​
FieldTypeDescription
codestringItem code
insurancePricenumberInsurance price
laboratoryPricenumberLaboratory price
patientPricenumberClient price
InvoiceExportInvoiceInfo ​
FieldTypeDescription
idInvoiceuuidDocument identifier
idSupervisoruuidIdentifier of the responsible person on the document
dateIssuedatetimeIssue date
dateDuedatetimeDue date
dateTaxdatetimeTaxable supply date
dateLastChangedatetimeLast change date
invoiceNumberlongDocument number
accountNumberstringAccount number
bankCodestringBank code
billingNamestringBilling first name
billingSurnamestringBilling last name
billingStreetstringBilling street
billingCitystringBilling city
billingPoststringBilling ZIP/postal code
billingRegNumberstringCompany registration number
billingVatNumberstringVAT ID
billingTypestringPayment type
officeNamestringOffice/company name
officeStreetstringOffice street
officeCitystringOffice city
officePoststringOffice ZIP/postal code
officeCountrystringOffice country
officeEmailstringOffice email
officePhonestringOffice phone
officeWebstringOffice web
currencystringCurrency of the account. priceTotal, priceDiscount, priceService, priceMaterial, priceDebt and payments are in this currency
currencyTotalstringCurrency in which the document is issued. Empty for documents in the account currency
currencyRatenumberExchange rate: units of currency per 1 unit of currencyTotal
depositnumberLegacy deposit, 0 on new documents. Not included in priceDebt
discountnumberDiscount
eetLockintFlag indicating the document is locked after being sent to EET
ibanstringIBAN
swiftstringSWIFT
typestringDocument type
invoiceVatboolWhether the document is issued with VAT
notestringNote
paidboolWhether the document is paid
priceDiscountnumberDiscount amount
priceLaboratorynumberLaboratory price
priceMaterialnumberMaterial price
priceServicenumberService price
priceTotalnumberTotal price
priceCreditnumberAmount covered by client credit, in the document currency (currencyTotal)
priceDebtnumberDebt amount in currency
providerNamestringResponsible person first name
providerSurnamestringResponsible person last name
providerDegreestringTitle before name
providerDegreeAfterstringTitle after name
regNumberstringRegistration number of the location that issued the document
vatNumberstringVAT ID of the location that issued the document
variableSymbolstringPayment gateway order number, if one is recorded for the document
writtenBystringIssued by
providerIdintNumeric ID of the responsible person
itemsInvoiceExportDetailInfo[]Document line items
paymentsInvoiceExportPaymentInfo[]Document payments
InvoiceExportDetailInfo ​
FieldTypeDescription
idInvoiceDetailuuidDocument item identifier
idParentuuidParent item identifier
idintItem sequence number
parentIdintParent item sequence number
codestringItem code
codeTypestringCode type
descriptionstringDescription
durationintProcedure duration
materialTypestringMaterial type
namestringItem name
notestringNote
positionintPosition in document
priceLaboratorynumberLaboratory price
pricePerMinutenumberPrice per minute
quantitynumberQuantity
unitPricenumberUnit price including VAT. In currency, for items from a price list kept in a foreign currency, in currencyTotal
vatRatestringItem VAT rate in percent
InvoiceExportPaymentInfo ​
FieldTypeDescription
idSupervisoruuidResponsible person identifier
pricePaymentnumberPaid amount in currency
datePaymentdatetimePayment date
notestringPayment note
billingTypestringPayment type
currencystringDocument currency
providerIdintNumeric ID of the responsible person
providerFirstnamestringResponsible person first name
providerLastnamestringResponsible person last name

type ​

ValueMeaning
INVOICE_TYPE_BILLInvoice
INVOICE_TYPE_INVOICEReceipt
INVOICE_TYPE_SPECIFICATIONPrice quote
INVOICE_TYPE_EXPENDITUREExpense document
INVOICE_TYPE_CREDITCredit top-up

billingType ​

The same values are used for both the invoice and the payment. On the invoice, the value may be empty if no payment type is set.

ValueMeaning
INVOICE_PAYMENT_TYPE_CASHCash
INVOICE_PAYMENT_TYPE_CARDPayment card
INVOICE_PAYMENT_TYPE_TRANSFERBank transfer
INVOICE_PAYMENT_TYPE_COUPONCoupon
INVOICE_PAYMENT_TYPE_OTHEROther

Calendar ​

POST /api/v1/ExportRequest/Calendar

Detailed calendar export for capacity overview, office hours, notes, and appointments/reservations in the selected period.

  • This export is available only in JSON format.

  • This export accepts a maximum range of 31 days.

  • Values in IdStaff must correspond to staff members with a calendar. If the request contains a user that is not a calendar staff member, the export fails with a validation error.

Parameters ​

ParameterTypeRequiredDescription
DateFromdatetimeyesStart of data range
DateTodatetimeyesEnd of data range
IdStaffuuid[]yesList of staff identifiers

Response ​

Response is a CalendarExtendedExportStaffDto[] array.

CalendarExtendedExportStaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
StaffNamestringStaff name
DaysCalendarExtendedExportDayDto[]Days in the requested period
CalendarExtendedExportDayDto ​
FieldTypeDescription
DatedatetimeDay date
AppointmentsCalendarExtendedExportAppointmentDto[]Appointments/reservations
NotesCalendarExtendedExportNoteDto[]Notes
OpenHoursCalendarExtendedExportOpenHourDto[]Office hours
IsHolidayboolHoliday flag
CalendarExtendedExportAppointmentDto ​
FieldTypeDescription
IdAppointmentuuidAppointment identifier
StartDatedatetimeAppointment start
EndDatedatetimeAppointment end
SubjectstringSubject
DescriptionstringDescription
IdClientuuidClient identifier
IdServiceuuidService identifier
EntryTypestringEntry type
OccurrenceTypestringOccurrence type
StatusstringAppointment status
OnlineBookedboolAppointment created online
ConfirmedboolAppointment confirmation
NoShowboolClient did not arrive
NewClientboolNew client
CalendarExtendedExportNoteDto ​
FieldTypeDescription
IdNoteuuidNote identifier
SubjectstringSubject
DescriptionstringDescription
OccurrenceTypestringOccurrence type
CalendarExtendedExportOpenHourDto ​
FieldTypeDescription
IdOpenHouruuidOffice hour identifier
StartDatedatetimeStart
EndDatedatetimeEnd
SubjectstringSubject
DescriptionstringDescription
OccurrenceTypestringOccurrence type
ActiveboolActive office hour
ActiveOverrideboolOverridden by exception

EntryType ​

ValueMeaning
CLIENT_APPOINTMENTClient appointment (record has IdClient)
STAFF_RESERVATIONStaff reservation (record has no IdClient)

OccurrenceType ​

ValueMeaning
ONE_OFFOne-time record
RECURRINGRecurring record
EDITED_EXCEPTIONEdited exception of a recurring record
DELETED_EXCEPTIONDeleted exception of a recurring record

Status ​

ValueMeaning
ORDEREDOrdered
CONFIRMEDConfirmed
WAITINGWaiting
TAKING_CAREIn treatment
TAKEN_CARETreated
FINISHEDFinished
NOT_ARRIVEDDid not arrive

Statistics exports ​

In statistics exports:

  • listed exports support both CSV and JSON formats,
  • CSV format is 1:1 equivalent to table exports in XDENT statistics,
  • the response documented below describes the JSON version of the export.

Cash register ​

Basic ​

POST /api/v1/ExportRequest/Statistics/Invoice/Basic

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by invoice issue date
DateTodatetimeyesEnd of range by invoice issue date
IdSupervisoruuidnoFilter by responsible person
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInvoiceItemsBasicExportDto[] array.

StatsInvoiceItemsBasicExportDto ​
FieldTypeDescription
InvoiceCodeInvoiceCodeDtoInvoice item
SupervisorSupervisorDtoResponsible person
LaboratoryLaboratoryDtoLaboratory (if available)
SupervisorDto ​
FieldTypeDescription
IdSupervisoruuidResponsible person identifier
NamestringResponsible person name
LaboratoryDto ​
FieldTypeDescription
IdLaboratoryuuidLaboratory identifier
NamestringLaboratory name
InvoiceCodeDto ​
FieldTypeDescription
IdInvoiceCodeuuidInvoice code identifier
CodestringItem code
NamestringItem name
DescriptionstringItem description
QuantitynumberQuantity
PricenumberPrice
PriceNoVatnumberPrice without VAT
PriceLaboratorynumberLaboratory price
TypeItemTypeDtoItem type
VatVatDtoVAT
ItemTypeDto ​
FieldTypeDescription
IdCodeTypeuuidCode type identifier
CodeTypestringType code
IdMaterialCodeuuidMaterial type identifier
MaterialCodeTypestringMaterial type
CodeGroupTypestringGroup code
CodeGroupTypeTitlestringGroup title
VatDto ​
FieldTypeDescription
IdVatRateuuidVAT rate identifier
RateCodestringRate code
RateintVAT rate value

Extended ​

POST /api/v1/ExportRequest/Statistics/Invoice/Extended

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by invoice issue date
DateTodatetimeyesEnd of range by invoice issue date
IdSupervisoruuidnoFilter by responsible person
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInvoiceItemsExtendedExportDto[] array.

StatsInvoiceItemsExtendedExportDto ​
FieldTypeDescription
ClientClientDtoClient
InvoiceInvoiceDtoDocument
InvoiceCodeInvoiceCodeDtoInvoice item
SupervisorSupervisorDtoResponsible person
LaboratoryLaboratoryDtoLaboratory
LocationLocationDtoLocation
CustomTagsCustomTagEntry[]Client custom tags
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
ClientNamestringClient name
PersonalIdstringPersonal ID
InvoiceDto ​
FieldTypeDescription
InvoiceNumberlongDocument number
DateIssuedatetimeIssue date
IsPaidboolPaid flag
IsFullyPaidboolDocument is fully paid
SupervisorDto ​
FieldTypeDescription
IdSupervisoruuidResponsible person identifier
NamestringResponsible person name
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name
CustomTagEntry ​
FieldTypeDescription
customTagNamestringCustom tag name
colorstringTag color
InvoiceCodeDto ​
FieldTypeDescription
IdInvoiceCodeuuidInvoice code identifier
CodestringItem code
NamestringItem name
DescriptionstringItem description
QuantitynumberQuantity
PricenumberPrice
PriceNoVatnumberPrice without VAT
PriceLaboratorynumberLaboratory price
DurationintProcedure duration
LocalizationCodestringLocalization code
NotestringNote
TypeItemTypeDtoItem type
VatVatDtoVAT
VatDto ​
FieldTypeDescription
IdVatRateuuidVAT rate identifier
RateCodestringRate code
RateintVAT rate value
ItemTypeDto ​
FieldTypeDescription
IdCodeTypeuuidCode type identifier
CodeTypestringCode type
IdMaterialCodeuuidMaterial type identifier
MaterialCodeTypestringMaterial type
CodeGroupTypestringGroup code
CodeGroupTypeTitlestringGroup title
LaboratoryDto ​
FieldTypeDescription
IdLaboratoryuuidLaboratory identifier
NamestringLaboratory name

Items ​

POST /api/v1/ExportRequest/Statistics/Invoice/Items

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by invoice issue date
DateTodatetimeyesEnd of range by invoice issue date
IdSupervisoruuidnoFilter by responsible person
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInvoiceItemsExportDto[] array.

StatsInvoiceItemsExportDto ​
FieldTypeDescription
ItemItemDtoInvoice item
LocationLocationDtoLocation
TypeTypeDtoItem type
QuantitynumberQuantity
PricenumberPrice
PriceNoVatnumberPrice without VAT
VRateintVAT rate
ItemDto ​
FieldTypeDescription
CodestringItem code
NamestringItem name
DescriptionstringItem description
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name
TypeDto ​
FieldTypeDescription
IdCodeTypeuuidCode type identifier
TypeCodestringType code
IdMaterialTypeuuidMaterial type identifier
MaterialTypeCodestringMaterial type
GroupCodestringGroup code
GroupTitlestringGroup title

Payment gateway ​

POST /api/v1/ExportRequest/Statistics/Invoice/PaymentGateway

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by invoice issue date
DateTodatetimeyesEnd of range by invoice issue date
IdSupervisoruuidnoFilter by responsible person
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInvoicePaymentGatewayExportDto[] array.

StatsInvoicePaymentGatewayExportDto ​
FieldTypeDescription
IdPaymentGatewayRequestuuidPayment gateway request identifier
LocationLocationDtoLocation
ClientClientDtoClient
InvoiceInvoiceDtoDocument
SupervisorSupervisorDtoResponsible person
AppointmentAppointmentDtoAppointment
ServiceServiceDtoService
PricenumberPrice
DateIssuedatetimeIssue date
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
NamestringClient name
InvoiceDto ​
FieldTypeDescription
IdInvoiceuuidDocument identifier
InvoiceNumberlongDocument number
OrderNumberlongPayment gateway order number
SupervisorDto ​
FieldTypeDescription
IdSupervisoruuidResponsible person identifier
NamestringResponsible person name
AppointmentDto ​
FieldTypeDescription
IdAppointmentuuidAppointment identifier
IdStaffuuidStaff identifier on appointment
StartDatedatetimeAppointment start
EndDatedatetimeAppointment end
AppointmentDateDisplaystringText representation of the appointment date (if available)
ServiceDto ​
FieldTypeDescription
IdServiceuuidService identifier
CaptionstringService name

Insurance ​

Documents ​

POST /api/v1/ExportRequest/Statistics/Insurance/Invoice

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by billing date
DateTodatetimeyesEnd of range by billing date
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInsuranceInvoiceExportDto[] array.

StatsInsuranceInvoiceExportDto ​
FieldTypeDescription
ReportReportDtoReporting information
ClientClientDtoClient
StaffStaffDtoStaff
PricingPricingDtoPrices
ReportDto ​
FieldTypeDescription
IdReportuuidRecord identifier
DatedatetimeRecord date
IdBatchuuidBatch identifier
BatchNumberlongBatch number
DocumentNumberlongDocument number
CreatedAtdatetimeCreation date
InsuranceInsuranceDtoInsurance company
SentboolSent flag
InsuranceDto ​
FieldTypeDescription
IdInsuranceuuidInsurance company identifier
NamestringInsurance company name
IdInsuranceTypeuuidInsurance type identifier
TypeNamestringInsurance type name
PricingDto ​
FieldTypeDescription
InsuranceTotalnumberTotal for insurance company
ClientTotalnumberTotal for client
LaboratoryPricenumberLaboratory price
ProfitnumberResult (insurance + client − laboratory)
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
NamestringClient name
PersonalIdstringPersonal ID
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
NamestringStaff name

Basic ​

POST /api/v1/ExportRequest/Statistics/Insurance/Basic

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by billing date
DateTodatetimeyesEnd of range by billing date
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInsuranceBasicExportDto[] array.

StatsInsuranceBasicExportDto ​
FieldTypeDescription
StaffStaffDtoStaff
ItemItemDtoItem
InsuranceInsuranceDtoInsurance company
PricesPricesDtoPrices
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
NamestringStaff name
ItemDto ​
FieldTypeDescription
CodestringItem code
NamestringItem name
TypestringItem type code
TypeNamestringLocalized item type title (if available)
AmountnumberQuantity
InsuranceDto ​
FieldTypeDescription
IdInsuranceuuidInsurance company identifier
NamestringInsurance company name
PricesDto ​
FieldTypeDescription
InsurancePricenumberInsurance price
ClientPricenumberClient price
LaboratoryPricenumberLaboratory price

Extended ​

POST /api/v1/ExportRequest/Statistics/Insurance/Extended

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by billing date
DateTodatetimeyesEnd of range by billing date
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInsuranceExtendedExportDto[] array.

StatsInsuranceExtendedExportDto ​
FieldTypeDescription
StaffStaffDtoStaff
ClientClientDtoClient
ItemItemDtoItem
InsuranceInsuranceDtoInsurance company
LaboratoryLaboratoryDtoLaboratory
ReportReportDtoRecord data
PricesPricesDtoPrices
CustomTagsCustomTagEntry[]Client custom tags
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
NamestringStaff name
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
NamestringClient name
PersonalIdstringPersonal ID
AddressAddressDtoClient address
AddressDto ​
FieldTypeDescription
CitystringCity
StreetstringStreet
PoststringZIP/postal code
ItemDto ​
FieldTypeDescription
CodestringItem code
NamestringItem name
CodeTypestringItem type code
AmountnumberQuantity
LocalizationintTooth localization
InsuranceDto ​
FieldTypeDescription
IdInsuranceuuidInsurance company identifier
NamestringInsurance company name
InsuranceTypeInsuranceTypeDtoInsurance type (if available)
InsuranceTypeDto ​
FieldTypeDescription
IdInsuranceTypeuuidInsurance type identifier
ClientInsuranceTypestringInsurance type name
LaboratoryDto ​
FieldTypeDescription
IdLaboratoryuuidLaboratory identifier
NamestringLaboratory name
ReportDto ​
FieldTypeDescription
ReportDatedatetimeRecord date
DiagnosestringDiagnosis
PaymentTypestringInsurance payment type (if available)
PricesDto ​
FieldTypeDescription
InsurancePricenumberInsurance price
ClientPricenumberClient price
LaboratoryPricenumberLaboratory price
CustomTagEntry ​
FieldTypeDescription
customTagNamestringCustom tag name
colorstringTag color

Items ​

POST /api/v1/ExportRequest/Statistics/Insurance/Items

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by billing date
DateTodatetimeyesEnd of range by billing date
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInsuranceItemsExportDto[] array.

StatsInsuranceItemsExportDto ​
FieldTypeDescription
CodestringItem code
NamestringItem name
AmountnumberQuantity
TypeItemTypeDtoItem type
PricesPricesDtoPrices
LocationLocationDtoLocation
ItemTypeDto ​
FieldTypeDescription
CodeTypestringItem type code
CodeTypeTitlestringLocalized item type title
PricesDto ​
FieldTypeDescription
InsurancePricenumberInsurance price
ClientPricenumberClient price
LaboratoryPricenumberLaboratory price
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name

Register ​

POST /api/v1/ExportRequest/Statistics/Insurance/Register

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by registration date
DateTodatetimeyesEnd of range by registration date
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInsuranceRegisterExportDto[] array.

StatsInsuranceRegisterExportDto ​
FieldTypeDescription
RegistrationDatedatetimeRegistration date
ClientClientDtoClient
InsuranceInsuranceDtoInsurance company
StaffStaffDtoInsurance staff member
BatchBatchDtoBatch
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
NamestringClient name
PersonalIdstringPersonal ID
InsuranceDto ​
FieldTypeDescription
IduuidInsurance company identifier
NamestringInsurance company name
TypeTypeDtoInsurance type
TypeDto ​
FieldTypeDescription
IduuidInsurance type identifier
NamestringInsurance type name
StaffDto ​
FieldTypeDescription
IduuidStaff identifier
NamestringStaff name
IcpstringICP
BatchDto ​
FieldTypeDescription
CreatedAtdatetimeBatch creation date
NumberlongBatch number

Batches ​

POST /api/v1/ExportRequest/Statistics/Insurance/Davky

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by batch period
DateTodatetimeyesEnd of range by batch period
ValidboolyesFilter valid / invalid records
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsInsuranceDavkyExportDto[] array.

StatsInsuranceDavkyExportDto ​
FieldTypeDescription
InvoiceInvoiceDtoBatch/document
InsuranceInsuranceDtoInsurance company
StaffStaffDtoStaff
LocationLocationDtoLocation
InvoiceDto ​
FieldTypeDescription
IdInsuranceInvoiceuuidInsurance batch identifier
PeriodStartdatetimePeriod start
PeriodEnddatetimePeriod end
VCISlongVCIS number
DCISlongDCIS number
AHCIDlongAHCID value
ZHCIDlongZHCID value
HCIDlongHCID value
InvoiceTypestringBatch type
CarestringCare type
TotalPricenumberTotal price
TotalPointnumberTotal points
DescriptionstringDescription
CreatedDatedatetimeCreation date
InsuranceDto ​
FieldTypeDescription
IdInsuranceCompanyuuidInsurance company identifier
CodestringInsurance code
IdInsuranceTypeuuidInsurance type identifier
InsuranceTypeNamestringInsurance type name
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullNamestringStaff name
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name

Staff ​

Item types ​

POST /api/v1/ExportRequest/Statistics/Staff/Items

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by payment date
DateTodatetimeyesEnd of range by payment date
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsStaffItemsExportDto[] array.

StatsStaffItemsExportDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
StaffFullNamestringStaff name
IdLocationuuidLocation identifier
LocationNamestringLocation name
InvoiceInvoiceDtoDirect payments summary
InsuranceInsuranceDtoInsurance summary
LaboratoryLaboratoryDtoLaboratory summary
MaterialPaymentnumberConsumable material
ClientCountintClient count
ReportCountintRecord count
CreditCreditDtoCredit movements
ProfitnumberResult
InvoiceDto ​
FieldTypeDescription
TotalnumberTotal direct payments
SellPaymentnumberSales
DirectPaymentnumberDirect payments
ServicePaymentnumberService payments
ClientPaymentnumberClient payments
OtherPaymentnumberOther payments
DiscountPricenumberDiscounts
ExpenditurePaymentnumberExpenses
OtherInvoiceNumsstringRelated document numbers
InsuranceDto ​
FieldTypeDescription
TotalnumberInsurance total
MaterialPricenumberMaterial for insurance
ServicePricenumberServices for insurance
LaboratoryDto ​
FieldTypeDescription
TotalnumberLaboratory total
InsuranceLaboratoryPricenumberLaboratory price from insurance
InvoiceLaboratoryPricenumberLaboratory price from cash register
CreditDto ​
FieldTypeDescription
DepositnumberCredit deposits
WithdrawnumberCredit withdrawals

Payment type ​

POST /api/v1/ExportRequest/Statistics/Staff/Type

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by payment date
DateTodatetimeyesEnd of range by payment date
IdLocationuuidnoFilter by location
Response ​

Response is a StatsStaffTypeExportDto[] array.

StatsStaffTypeExportDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
StaffFullNamestringStaff name
IdLocationuuidLocation identifier
LocationNamestringLocation name
PaymentPaymentDtoPayment breakdown by type
PaymentDto ​
FieldTypeDescription
TotalnumberTotal payments
CashnumberCash
CardnumberCard
TransfernumberTransfer
CouponnumberVoucher
OthernumberOther
CreditnumberCredit payment

Clients ​

Active ​

POST /api/v1/ExportRequest/Statistics/Client/Active

Parameters ​
ParameterTypeRequiredDescription
IdLocationuuidnoFilter by location
Response ​

Response is a StatsClientActiveExportDto[] array.

StatsClientActiveExportDto ​
FieldTypeDescription
StaffStaffDtoStaff
ClientCountintActive client count
StaffDto ​
FieldTypeDescription
IduuidStaff identifier
NamestringStaff name

Credit ​

POST /api/v1/ExportRequest/Statistics/Client/Credit

  • This export accepts only DateTo and returns the credit balance as of that date.
Parameters ​
ParameterTypeRequiredDescription
DateTodatetimeyesCredit state as of this date
IdLocationuuidnoFilter by location
Response ​

Response is a StatsClientCreditExportDto[] array.

StatsClientCreditExportDto ​
FieldTypeDescription
LocationLocationDtoLocation
StaffStaffDtoStaff
ClientClientDtoClient
CreditnumberCredit amount
CurrencyCodestringCurrency code
InvoiceNumbersstring[]Document numbers
LocationDto ​
FieldTypeDescription
NamestringLocation name
StaffDto ​
FieldTypeDescription
NamestringStaff name
ClientDto ​
FieldTypeDescription
NamestringClient name
PhonestringClient phone
EmailstringClient email
AddressstringClient address
PidstringPersonal ID
TagsCustomTagEntry[]Client custom tags
CustomTagEntry ​
FieldTypeDescription
customTagNamestringCustom tag name
colorstringTag color

Debt ​

POST /api/v1/ExportRequest/Statistics/Client/Debt

  • This export accepts a date range for debt within the selected period.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of debt period
DateTodatetimeyesEnd of debt period
IdLocationuuidnoFilter by location
Response ​

Response is a StatsClientDebtExportDto[] array.

StatsClientDebtExportDto ​
FieldTypeDescription
StaffStaffDtoStaff
ClientClientDtoClient
DebtnumberDebt amount
InvoiceNumbersstring[]Document numbers
StaffDto ​
FieldTypeDescription
NamestringStaff name
ClientDto ​
FieldTypeDescription
NamestringClient name
PhonestringClient phone
EmailstringClient email
AddressstringClient address
PidstringPersonal ID
TagsCustomTagEntry[]Client custom tags
CustomTagEntry ​
FieldTypeDescription
customTagNamestringCustom tag name
colorstringTag color

Insurance ​

POST /api/v1/ExportRequest/Statistics/Client/Insurance

Parameters ​

This endpoint has no request body parameters.

Response ​

Response is a StatsClientInsuranceExportDto[] array.

StatsClientInsuranceExportDto ​
FieldTypeDescription
InsurancestringInsurance code and name
ClientCountintClient count

Deleted ​

POST /api/v1/ExportRequest/Statistics/Client/Deleted

Parameters ​
ParameterTypeRequiredDescription
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsClientDeletedExportDto[] array.

StatsClientDeletedExportDto ​
FieldTypeDescription
ClientClientDtoClient
DeletionDeletionDtoDeletion information
ClientDto ​
FieldTypeDescription
IduuidClient identifier
FullNamestringClient full name
PersonalIdstringPersonal ID
ContactContactDtoContact details
AddressAddressDtoClient address
ContactDto ​
FieldTypeDescription
PhonestringClient phone
EmailstringClient email
AddressDto ​
FieldTypeDescription
StreetstringStreet
CitystringCity
PoststringZIP/postal code
DeletionDto ​
FieldTypeDescription
ReasonIduuidDeletion reason identifier
ReasonTitlestringDeletion reason name
DeletedAtdatetimeDeletion date

Extended ​

POST /api/v1/ExportRequest/Statistics/Client/Extended

  • This export accepts a date range by creation date of records and documents.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range
DateTodatetimeyesEnd of range
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsClientExtendedExportDto[] array.

StatsClientExtendedExportDto ​
FieldTypeDescription
ClientClientDtoClient
MedicalReportMedicalReportDtoMedical record data
InvoiceInvoiceDtoCash register data
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
NamestringClient name
MedicalReportDto ​
FieldTypeDescription
DirectPaymentsnumberDirect payments in documentation
AdditionalPaymentnumberAdditional payments in documentation
LaboratorynumberLaboratory part in documentation
InsurancenumberInsurance part in documentation
RecordCountintMedical record count
InvoiceDto ​
FieldTypeDescription
DirectPaymentsnumberDirect payments in cash register
AdditionalPaymentnumberAdditional payments in cash register
LaboratorynumberLaboratory part in cash register
DiscountnumberDiscounts
CreditnumberCredit
InvoiceCountintDocument count

Calendar ​

Active ​

POST /api/v1/ExportRequest/Statistics/Calendar/Active

  • This export accepts a date range by appointment date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by appointment date
DateTodatetimeyesEnd of range by appointment date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsCalendarActiveExportDto[] array.

StatsCalendarActiveExportDto ​
FieldTypeDescription
AppointmentAppointmentDtoAppointment
StaffStaffDtoStaff
ClientClientDtoClient
BookingBookingDtoBooking information
MetaMetaDtoMetadata
AppointmentDto ​
FieldTypeDescription
StartDatedatetimeAppointment start
ServicestringService name
StatusintAppointment status
StatusNamestringStatus name (if available)
DurationintAppointment duration in minutes
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullNamestringStaff name
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullNamestringClient name
PhonestringClient phone
EmailstringClient email
DescriptionstringClient/appointment note
BookingDto ​
FieldTypeDescription
OnlineBookedboolBooked online
FindUsstringSource describing how the client found the office
MetaDto ​
FieldTypeDescription
CreatedDatedatetimeCreation date
LastUpdateDatedatetimeLast update date
CustomTagsCustomTagEntry[]Client custom tags
CustomTagEntry ​
FieldTypeDescription
customTagNamestringCustom tag name
colorstringTag color

Deleted ​

POST /api/v1/ExportRequest/Statistics/Calendar/Deleted

  • This export accepts a date range by appointment date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by appointment date
DateTodatetimeyesEnd of range by appointment date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsCalendarDeletedExportDto[] array.

StatsCalendarDeletedExportDto ​
FieldTypeDescription
AppointmentAppointmentDtoAppointment
StaffStaffDtoStaff
ClientClientDtoClient
CancellationCancellationDtoCancellation information
AppointmentDto ​
FieldTypeDescription
StartDatedatetimeAppointment start
ServicestringService name
DurationintAppointment duration in minutes
DescriptionstringAppointment description
CreatedDatedatetimeCreation date
LastUpdateDatedatetimeLast update date
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullNamestringStaff name
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullNamestringClient name
PhonestringClient phone
EmailstringClient email
CustomTagsCustomTagEntry[]Client custom tags
CustomTagEntry ​
FieldTypeDescription
customTagNamestringCustom tag name
colorstringTag color
CancellationDto ​
FieldTypeDescription
DateCanceldatetimeCancellation date
CancelReasonstringCancellation reason
IdStaffCanceluuidIdentifier of user who canceled
StaffFullNameCancelstringName of user who canceled

New/Updated ​

POST /api/v1/ExportRequest/Statistics/Calendar/NewUpdated

  • This export accepts a date range by last update date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by last update date
DateTodatetimeyesEnd of range by last update date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsCalendarNewUpdatedExportDto[] array.

StatsCalendarNewUpdatedExportDto ​
FieldTypeDescription
AppointmentAppointmentDtoAppointment including create/update information
AppointmentDto ​
FieldTypeDescription
StartDatedatetimeAppointment start
EndDatedatetimeAppointment end
ServicestringService name
StatusintAppointment status
StatusNamestringStatus name (if available)
DurationintAppointment duration in minutes
IsNewboolNewly created appointment
EventTypeintRecord type
OnlineBookedboolBooked online
CreatedDatedatetimeCreation date
LastUpdateDatedatetimeLast update date
StaffStaffDtoAppointment staff
ClientClientDtoClient
CreatorCreatorDtoUser who created the record
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullNamestringStaff name
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullNamestringClient name
PhonestringClient phone
EmailstringClient email
DescriptionstringClient/appointment note
CustomTagsCustomTagEntry[]Client custom tags
CreatorDto ​
FieldTypeDescription
IdStaffuuidIdentifier of user who created/updated the record
FullNamestringName of user who created/updated the record
CustomTagEntry ​
FieldTypeDescription
customTagNamestringCustom tag name
colorstringTag color

Follow-up care ​

POST /api/v1/ExportRequest/Statistics/Calendar/Dispenzarizace

  • This export accepts a date range by follow-up care date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by follow-up care date
DateTodatetimeyesEnd of range by follow-up care date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsCalendarDispenzarizaceExportDto[] array.

StatsCalendarDispenzarizaceExportDto ​
FieldTypeDescription
VisitVisitDtoVisit information
ClientClientDtoClient
StaffStaffDtoStaff
LocationLocationDtoLocation
VisitDto ​
FieldTypeDescription
DateVisitdatetimeVisit date
ServiceCaptionstringService name
ServiceDescriptionstringService description
ServiceCreatedOndatetimeService creation date
BookedboolIndicates the visit is booked
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullNamestringClient name
PhonestringClient phone
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullNamestringStaff name
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name

Waiting ​

POST /api/v1/ExportRequest/Statistics/Calendar/Waiting

Parameters ​
ParameterTypeRequiredDescription
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsCalendarWaitingExportDto[] array.

StatsCalendarWaitingExportDto ​
FieldTypeDescription
ClientClientDtoClient
ServiceServiceDtoService
StaffStaffDtoStaff
LocationLocationDtoLocation
NotestringNote
DateAddeddatetimeDate added
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullNamestringClient name
PhonestringClient phone
ServiceDto ​
FieldTypeDescription
IdServiceuuidService identifier
CaptionstringService name
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullNamestringStaff name
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name

Forms ​

Signed ​

POST /api/v1/ExportRequest/Statistics/Forms/Signed

  • This export accepts a date range by signature date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by signature date
DateTodatetimeyesEnd of range by signature date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsFormSignedExportDto[] array.

StatsFormSignedExportDto ​
FieldTypeDescription
ClientClientDtoClient
StaffStaffDtoStaff
FormFormDtoForm
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullnamestringClient name
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullnamestringStaff name
FormDto ​
FieldTypeDescription
IdFormRequestuuidForm identifier
NamestringForm name
StatusCodestringForm status code
StatusTextstringForm status text
DateSigneddatetimeSignature date
ValidUntildatetimeExpiration date

Expiring ​

POST /api/v1/ExportRequest/Statistics/Forms/Expiring

  • This export accepts a date range for validity period.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of validity range
DateTodatetimeyesEnd of validity range
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsFormExpiringExportDto[] array.

StatsFormExpiringExportDto ​
FieldTypeDescription
ClientClientDtoClient
StaffStaffDtoStaff
FormFormDtoForm
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullnamestringClient name
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullnamestringStaff name
FormDto ​
FieldTypeDescription
IdFormRequestuuidForm identifier
NamestringForm name
ValidUntildatetimeExpiration date
DateSigneddatetimeSignature date

Store ​

Items ​

POST /api/v1/ExportRequest/Statistics/Store/Items

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by operation date
DateTodatetimeyesEnd of range by operation date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsStoreItemsExportDto[] array.

StatsStoreItemsExportDto ​
FieldTypeDescription
OperationDatedatetimeOperation date
DocumentNumberstringDocument number
StaffStaffDtoStaff
StoreStoreDtoStore
PartnerPartnerDtoOperation partner
OperationOperationDtoOperation type and code
MaterialMaterialDtoMaterial
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
NamestringStaff name
StoreDto ​
FieldTypeDescription
IdStoreuuidStore identifier
NamestringStore name
PartnerDto ​
FieldTypeDescription
IduuidPartner identifier
NamestringPartner name
OperationDto ​
FieldTypeDescription
TypestringStore operation type
CodestringStore operation code
MaterialDto ​
FieldTypeDescription
CodestringMaterial code
NamestringMaterial name
LotstringLot
ExpirationdatetimeExpiration date
QuantitynumberQuantity
PricenumberPrice

Documentation ​

Medical records ​

POST /api/v1/ExportRequest/Statistics/Documentation/MedicalReport

  • This export accepts date ranges by medical record date and by last update date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by record date
DateTodatetimeyesEnd of range by record date
LastUpdateFromdatetimeyesStart of range by last update date
LastUpdateTodatetimeyesEnd of range by last update date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsDocumentationMedicalReportExportDto[] array.

StatsDocumentationMedicalReportExportDto ​
FieldTypeDescription
MedicalReportMedicalReportDtoMedical record
StaffStaffDtoStaff
LocationLocationDtoLocation
ClientClientDtoClient
MedicalReportDto ​
FieldTypeDescription
IdMedicalReportuuidMedical record identifier
CreateddatetimeCreation date
LastUpdatedatetimeLast update date
IsDigitalSignboolDigital signature flag
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
StaffFullNamestringStaff name
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
LocationNamestringLocation name
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
ClientFullNamestringClient name
PersonalIdstringPersonal ID
PhonestringClient phone

Created drafts ​

POST /api/v1/ExportRequest/Statistics/Documentation/Draft

  • This export accepts a date range by draft creation date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by draft creation date
DateTodatetimeyesEnd of range by draft creation date
IdDoctoruuidnoFilter by doctor
IdStaffuuidnoFilter by staff member
IdLocationuuidnoFilter by location
Response ​

Response is a StatsDocumentationDraftExportDto[] array.

StatsDocumentationDraftExportDto ​
FieldTypeDescription
IdMedicalReportuuidRecord identifier
CreateddatetimeCreation date
IsInsuranceboolDraft intended for insurance reporting
AuthorizeStaffAuthorizeStaffDtoApprover
DraftStaffDraftStaffDtoDraft author
InsuranceStaffInsuranceStaffDtoReporting person
LocationLocationDtoLocation
ClientClientDtoClient
AuthorizeStaffDto ​
FieldTypeDescription
IduuidApprover identifier
FullNamestringApprover name
DraftStaffDto ​
FieldTypeDescription
IduuidDraft author identifier
FullNamestringDraft author name
InsuranceStaffDto ​
FieldTypeDescription
IduuidReporting person identifier
FullNamestringReporting person name
LocationDto ​
FieldTypeDescription
IduuidLocation identifier
NamestringLocation name
ClientDto ​
FieldTypeDescription
IduuidClient identifier
FullNamestringClient name
PersonalIdstringPersonal ID

Direct payments ​

POST /api/v1/ExportRequest/Statistics/Documentation/DirectPayment

  • This export accepts a date range by medical record date.
Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by record date
DateTodatetimeyesEnd of range by record date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsDocumentationDirectPaymentExportDto[] array.

StatsDocumentationDirectPaymentExportDto ​
FieldTypeDescription
IdMedicalReportuuidRecord identifier
CreateddatetimeCreation date
SupervisorSupervisorDtoResponsible person
LocationLocationDtoLocation
ClientClientDtoClient
ItemInvoiceItemDtoInvoice item
SupervisorDto ​
FieldTypeDescription
IduuidResponsible person identifier
NamestringResponsible person name
LocationDto ​
FieldTypeDescription
IduuidLocation identifier
NamestringLocation name
ClientDto ​
FieldTypeDescription
IduuidClient identifier
NamestringClient name
InvoiceItemDto ​
FieldTypeDescription
IdInvoiceCodeuuidItem code identifier
CodestringItem code
DurationintProcedure duration
QuantitynumberQuantity
PricenumberPrice

Notifications ​

Answers ​

POST /api/v1/ExportRequest/Statistics/Notifications/Answers

Parameters ​
ParameterTypeRequiredDescription
DateFromdatetimeyesStart of range by answer date
DateTodatetimeyesEnd of range by answer date
IdLocationuuidnoFilter by location
IdStaffuuidnoFilter by staff member
Response ​

Response is a StatsNotificationsAnswersExportDto[] array.

StatsNotificationsAnswersExportDto ​
FieldTypeDescription
AnswerAnswerDtoNotification answer
ClientClientDtoClient
AppointmentAppointmentDtoAppointment
StaffStaffDtoStaff
LocationLocationDtoLocation
AnswerDto ​
FieldTypeDescription
IdAnsweruuidAnswer identifier
DateReceiveddatetimeAnswer received date
ContentAnswerstringAnswer content
ContentOriginalstringOriginal message content
ArcStatusintAnswer evaluation: 0 = appointment confirmation, 1 = cancellation, 2 = unrecognized answer. null if automatic appointment confirmation is not active.
ConfirmedboolThe answer is marked as read in XDENT (automatically for a positive answer, otherwise manually by a user).
ClientDto ​
FieldTypeDescription
IdClientuuidClient identifier
FullnamestringClient name
PhonestringClient phone
AppointmentDto ​
FieldTypeDescription
IdAppointmentuuidAppointment identifier
StartDatedatetimeAppointment start
EndDatedatetimeAppointment end
IdServiceuuidService identifier
ServicestringService name
AppointmentDateDisplaystringText representation of the appointment date (if available)
StaffDto ​
FieldTypeDescription
IdStaffuuidStaff identifier
FullnamestringStaff name
LocationDto ​
FieldTypeDescription
IdLocationuuidLocation identifier
NamestringLocation name

Parameter notes ​

  • UUID values for IdLocation are available from Locations endpoints.
  • UUID values for IdStaff, IdSupervisor, and IdDoctor are available from Staff endpoints.